import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:stopmotion/config/default_activity_settings.dart';

class ActivitySettings {
  final String movieType;

  ActivitySettings({
    required this.movieType,
  });

  static String getMovieTypeValueFromUnsafe(String movieType) {
    if (DefaultActivitySettings.allowedMovieTypeValues.contains(movieType)) {
      return movieType;
    }

    return DefaultActivitySettings.defaultMovieTypeValue;
  }

  factory ActivitySettings.createDefault() {
    return ActivitySettings(
      movieType: DefaultActivitySettings.defaultMovieTypeValue,
    );
  }

  void dump() {
    printlog('$ActivitySettings:');
    printlog('  ${DefaultActivitySettings.parameterCodeMovieType}: $movieType');
    printlog('');
  }

  @override
  String toString() {
    return '$ActivitySettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultActivitySettings.parameterCodeMovieType: movieType,
    };
  }
}
